
#include "../shim.h"
#include "audio.fdh"

#define ADJUST_VOLUME(s, v)		(s = ((s*v) / SDL_MIX_MAXVOLUME))

int SDL_OpenAudio(SDL_AudioSpec *desired, SDL_AudioSpec *obtained)
{
	obtained->format = AUDIO_S16;
	obtained->channels = 2;
	obtained->samples = desired->samples;
	obtained->size = (obtained->samples * 2);
	
	return 0;
}

void SDL_PauseAudio(int pause_on)
{
}

void SDL_LockAudio(void)
{
}

void SDL_UnlockAudio(void)
{
}

void SDL_CloseAudio(void)
{
}

/*
void c------------------------------() {}
*/

// adapted from the real SDL_MixAudio.
// handles only 16bpp LSB audio data.
void SDL_MixAudio(uint8_t *dst, const uint8_t *src, uint32_t len, int volume)
{
	int16_t sample1, sample2;
	int dst_sample;
	#define MAX_AUDIOVAL	((1<<(16-1))-1)
	#define MIN_AUDIOVAL	-(1<<(16-1))
	
	len /= 2;
	while(len--)
	{
		sample1 = (src[1] << 8) | src[0];
		ADJUST_VOLUME(sample1, volume);
		sample2 = (dst[1] << 8) | dst[0];
		src += 2;
		
		dst_sample = (sample1 + sample2);
		
		if (dst_sample > MAX_AUDIOVAL) dst_sample = MAX_AUDIOVAL;
		else if (dst_sample < MIN_AUDIOVAL) dst_sample = MIN_AUDIOVAL;
		
		dst[0] = dst_sample; dst_sample >>= 8;
		dst[1] = dst_sample;
		dst += 2;
	}
}

