
@ r0 = src
@ r1 = dest
@ r2 = copy width
@ r3 = copy height
@ parm4 = source pitch minus (copy width * 2)
@ parm5 = dest pitch minus (copy width * 2)

.global asm_do_blit_transparent
asm_do_blit_transparent:
	stmfd	sp!, {r4-r7}
	
	ldr		r4, [sp, #16]		@ load source pitch
	ldr		r5, [sp, #20]		@ load dest pitch

heightLoop:
	mov		r6, r2				@ X pixels remaining
widthLoop:
	ldrh	r7, [r0], #2
	
	tst		r7, r7
	strneh	r7, [r1]
	add		r1, #2
	
	subs	r6, #1
	bne		widthLoop
	
	add		r0, r0, r4			@ add source pitch
	add		r1, r1, r5			@ add dest pitch
	
	subs	r3, #1
	bne		heightLoop
	
	ldmfd	sp!, {r4-r7}
	bx	lr
	

.global asm_do_blit_nontransparent
asm_do_blit_nontransparent:
	stmfd	sp!, {r4-r7}
	
	ldr		r4, [sp, #16]		@ load source pitch
	ldr		r5, [sp, #20]		@ load dest pitch

heightLoop2:
	mov		r6, r2				@ X pixels remaining
widthLoop2:
	ldrh	r7, [r0], #2
	strh	r7, [r1], #2
	
	subs	r6, #1
	bne		widthLoop2
	
	add		r0, r0, r4			@ add source pitch
	add		r1, r1, r5			@ add dest pitch
	
	subs	r3, #1
	bne		heightLoop2
	
	ldmfd	sp!, {r4-r7}
	bx	lr
	
	
@ r0 = dest
@ r1 = src
@ r2 = length

.global asm_fast_memcpy_2
asm_fast_memcpy_2:
	stmfd	sp!, {r3-r10}
	
	@ldr		r3, [r1], #4
	@ldr		r4, [r1], #4
	@ldr		r5, [r1], #4
	@ldr		r6, [r1], #4
	@ldr		r7, [r1], #4
	@ldr		r8, [r1], #4
	@ldr		r9, [r1], #4
	@ldr		r10, [r1], #4
	
	@str		r3, [r0], #4
	@str		r4, [r0], #4
	@str		r5, [r0], #4
	@str		r6, [r0], #4
	@str		r7, [r0], #4
	@str		r8, [r0], #4
	@str		r9, [r0], #4
	@str		r10, [r0], #4

copy_loop:
	ldrmib	pc, [r1, #0x60]
	ldrmib	pc, [r1, #0x80]

	ldmia	r1!, {r3-r10}
	stmia	r0!, {r3-r10}
	ldmia	r1!, {r3-r10}
	stmia	r0!, {r3-r10}
	
	subs	r2, r2, #0x40
	bne		copy_loop
	
done:
	ldmfd	sp!, {r3-r10}
	bx		lr
	
	

.global asm_fast_memcpy
asm_fast_memcpy:
	stmfd	sp!, {r3-r10}
	
	@ bytes -> groups of 16 words
	mov		r2, r2, lsr #5
	
old_copy_loop:
	ldmia	r1!, {r3-r10}
	subs	r2, r2, #1
	stmia	r0!, {r3-r10}
	bne		old_copy_loop
	
	ldmfd	sp!, {r3-r10}
	bx		lr








































